Index: src/molecule_dynamics.cpp
===================================================================
--- src/molecule_dynamics.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/molecule_dynamics.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -6,4 +6,5 @@
  */
 
+#include "World.hpp"
 #include "atom.hpp"
 #include "config.hpp"
@@ -13,4 +14,5 @@
 #include "molecule.hpp"
 #include "parser.hpp"
+#include "Plane.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -37,36 +39,32 @@
     // determine normalized trajectories direction vector (n1, n2)
     Sprinter = Params.PermutationMap[Walker->nr];   // find first target point
-    trajectory1.CopyVector(&Sprinter->Trajectory.R.at(Params.endstep));
-    trajectory1.SubtractVector(&Walker->Trajectory.R.at(Params.startstep));
+    trajectory1 = Sprinter->Trajectory.R.at(Params.endstep) - Walker->Trajectory.R.at(Params.startstep);
     trajectory1.Normalize();
     Norm1 = trajectory1.Norm();
     Sprinter = Params.PermutationMap[Runner->nr];   // find second target point
-    trajectory2.CopyVector(&Sprinter->Trajectory.R.at(Params.endstep));
-    trajectory2.SubtractVector(&Runner->Trajectory.R.at(Params.startstep));
+    trajectory2 = Sprinter->Trajectory.R.at(Params.endstep) - Runner->Trajectory.R.at(Params.startstep);
     trajectory2.Normalize();
     Norm2 = trajectory1.Norm();
     // check whether either is zero()
     if ((Norm1 < MYEPSILON) && (Norm2 < MYEPSILON)) {
-      tmp = Walker->Trajectory.R.at(Params.startstep).Distance(&Runner->Trajectory.R.at(Params.startstep));
+      tmp = Walker->Trajectory.R.at(Params.startstep).distance(Runner->Trajectory.R.at(Params.startstep));
     } else if (Norm1 < MYEPSILON) {
       Sprinter = Params.PermutationMap[Walker->nr];   // find first target point
-      trajectory1.CopyVector(&Sprinter->Trajectory.R.at(Params.endstep));  // copy first offset
-      trajectory1.SubtractVector(&Runner->Trajectory.R.at(Params.startstep));  // subtract second offset
-      trajectory2.Scale( trajectory1.ScalarProduct(&trajectory2) ); // trajectory2 is scaled to unity, hence we don't need to divide by anything
-      trajectory1.SubtractVector(&trajectory2);   // project the part in norm direction away
+      trajectory1 = Sprinter->Trajectory.R.at(Params.endstep) - Runner->Trajectory.R.at(Params.startstep);
+      trajectory2 *= trajectory1.ScalarProduct(trajectory2); // trajectory2 is scaled to unity, hence we don't need to divide by anything
+      trajectory1 -= trajectory2;   // project the part in norm direction away
       tmp = trajectory1.Norm();  // remaining norm is distance
     } else if (Norm2 < MYEPSILON) {
       Sprinter = Params.PermutationMap[Runner->nr];   // find second target point
-      trajectory2.CopyVector(&Sprinter->Trajectory.R.at(Params.endstep));  // copy second offset
-      trajectory2.SubtractVector(&Walker->Trajectory.R.at(Params.startstep));  // subtract first offset
-      trajectory1.Scale( trajectory2.ScalarProduct(&trajectory1) ); // trajectory1 is scaled to unity, hence we don't need to divide by anything
-      trajectory2.SubtractVector(&trajectory1);   // project the part in norm direction away
+      trajectory2 = Sprinter->Trajectory.R.at(Params.endstep) - Walker->Trajectory.R.at(Params.startstep);  // copy second offset
+      trajectory1 *= trajectory2.ScalarProduct(trajectory1); // trajectory1 is scaled to unity, hence we don't need to divide by anything
+      trajectory2 -= trajectory1;   // project the part in norm direction away
       tmp = trajectory2.Norm();  // remaining norm is distance
-    } else if ((fabs(trajectory1.ScalarProduct(&trajectory2)/Norm1/Norm2) - 1.) < MYEPSILON) { // check whether they're linear dependent
+    } else if ((fabs(trajectory1.ScalarProduct(trajectory2)/Norm1/Norm2) - 1.) < MYEPSILON) { // check whether they're linear dependent
   //        Log() << Verbose(3) << "Both trajectories of " << *Walker << " and " << *Runner << " are linear dependent: ";
   //        Log() << Verbose(0) << trajectory1;
   //        Log() << Verbose(0) << " and ";
   //        Log() << Verbose(0) << trajectory2;
-      tmp = Walker->Trajectory.R.at(Params.startstep).Distance(&Runner->Trajectory.R.at(Params.startstep));
+      tmp = Walker->Trajectory.R.at(Params.startstep).distance(Runner->Trajectory.R.at(Params.startstep));
   //        Log() << Verbose(0) << " with distance " << tmp << "." << endl;
     } else { // determine distance by finding minimum distance
@@ -78,5 +76,5 @@
   //        Log() << Verbose(0) << trajectory2 << endl;
       // determine normal vector for both
-      normal.MakeNormalVector(&trajectory1, &trajectory2);
+      normal = Plane(trajectory1, trajectory2,0).getNormal();
       // print all vectors for debugging
   //        Log() << Verbose(0) << "Normal vector in between: ";
@@ -84,8 +82,8 @@
       // setup matrix
       for (int i=NDIM;i--;) {
-        gsl_matrix_set(A, 0, i, trajectory1.x[i]);
-        gsl_matrix_set(A, 1, i, trajectory2.x[i]);
-        gsl_matrix_set(A, 2, i, normal.x[i]);
-        gsl_vector_set(x,i, (Walker->Trajectory.R.at(Params.startstep).x[i] - Runner->Trajectory.R.at(Params.startstep).x[i]));
+        gsl_matrix_set(A, 0, i, trajectory1[i]);
+        gsl_matrix_set(A, 1, i, trajectory2[i]);
+        gsl_matrix_set(A, 2, i, normal[i]);
+        gsl_vector_set(x,i, (Walker->Trajectory.R.at(Params.startstep)[i] - Runner->Trajectory.R.at(Params.startstep)[i]));
       }
       // solve the linear system by Householder transformations
@@ -95,12 +93,9 @@
   //        Log() << Verbose(0) << " with distance " << tmp << "." << endl;
       // test whether we really have the intersection (by checking on c_1 and c_2)
-      TestVector.CopyVector(&Runner->Trajectory.R.at(Params.startstep));
+      trajectory1.Scale(gsl_vector_get(x,0));
       trajectory2.Scale(gsl_vector_get(x,1));
-      TestVector.AddVector(&trajectory2);
       normal.Scale(gsl_vector_get(x,2));
-      TestVector.AddVector(&normal);
-      TestVector.SubtractVector(&Walker->Trajectory.R.at(Params.startstep));
-      trajectory1.Scale(gsl_vector_get(x,0));
-      TestVector.SubtractVector(&trajectory1);
+      TestVector = Runner->Trajectory.R.at(Params.startstep) + trajectory2 + normal
+                   - (Walker->Trajectory.R.at(Params.startstep) + trajectory1);
       if (TestVector.Norm() < MYEPSILON) {
   //          Log() << Verbose(2) << "Test: ok.\tDistance of " << tmp << " is correct." << endl;
@@ -162,6 +157,6 @@
 double molecule::ConstrainedPotential(struct EvaluatePotential &Params)
 {
-  double tmp, result;
-
+  double tmp = 0.;
+  double result = 0.;
   // go through every atom
   atom *Runner = NULL;
@@ -171,5 +166,5 @@
     // first term: distance to target
     Runner = Params.PermutationMap[Walker->nr];   // find target point
-    tmp = (Walker->Trajectory.R.at(Params.startstep).Distance(&Runner->Trajectory.R.at(Params.endstep)));
+    tmp = (Walker->Trajectory.R.at(Params.startstep).distance(Runner->Trajectory.R.at(Params.endstep)));
     tmp *= Params.IsAngstroem ? 1. : 1./AtomicLengthToAngstroem;
     result += Params.PenaltyConstants[0] * tmp;
@@ -207,5 +202,5 @@
     doubles++;
   if (doubles >0)
-    Log() << Verbose(2) << "Found " << doubles << " Doubles." << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Found " << doubles << " Doubles." << endl);
   Free(&DoubleList);
 //  Log() << Verbose(2) << zeile1.str() << endl << zeile2.str() << endl;
@@ -230,5 +225,5 @@
     while(Runner->next != mol->end) {
       Runner = Runner->next;
-      Params.DistanceList[Walker->nr]->insert( DistancePair(Walker->Trajectory.R.at(Params.startstep).Distance(&Runner->Trajectory.R.at(Params.endstep)), Runner) );
+      Params.DistanceList[Walker->nr]->insert( DistancePair(Walker->Trajectory.R.at(Params.startstep).distance(Runner->Trajectory.R.at(Params.endstep)), Runner) );
     }
   }
@@ -249,5 +244,5 @@
     Params.DoubleList[Params.DistanceList[Walker->nr]->begin()->second->nr]++;            // increase this target's source count (>1? not injective)
     Params.DistanceIterators[Walker->nr] = Params.DistanceList[Walker->nr]->begin();    // and remember which one we picked
-    Log() << Verbose(2) << *Walker << " starts with distance " << Params.DistanceList[Walker->nr]->begin()->first << "." << endl;
+    DoLog(2) && (Log() << Verbose(2) << *Walker << " starts with distance " << Params.DistanceList[Walker->nr]->begin()->first << "." << endl);
   }
 };
@@ -277,5 +272,5 @@
       Params.DistanceIterators[Walker->nr] = NewBase;
       OldPotential = Potential;
-      Log() << Verbose(3) << "Found a new permutation, new potential is " << OldPotential << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "Found a new permutation, new potential is " << OldPotential << "." << endl);
     }
   }
@@ -306,8 +301,8 @@
   for (int i=mol->AtomCount; i--;) // now each single entry in the DoubleList should be <=1
     if (Params.DoubleList[i] > 1) {
-      eLog() << Verbose(0) << "Failed to create an injective PermutationMap!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Failed to create an injective PermutationMap!" << endl);
       performCriticalExit();
     }
-  Log() << Verbose(1) << "done." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 };
 
@@ -358,5 +353,5 @@
   Params.PenaltyConstants[2] = 1e+7;    // just a huge penalty
   // generate the distance list
-  Log() << Verbose(1) << "Allocating, initializting and filling the distance list ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Allocating, initializting and filling the distance list ... " << endl);
   FillDistanceList(this, Params);
 
@@ -365,14 +360,14 @@
 
   // make the PermutationMap injective by checking whether we have a non-zero constants[2] term in it
-  Log() << Verbose(1) << "Making the PermutationMap injective ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Making the PermutationMap injective ... " << endl);
   MakeInjectivePermutation(this, Params);
   Free(&Params.DoubleList);
 
   // argument minimise the constrained potential in this injective PermutationMap
-  Log() << Verbose(1) << "Argument minimising the PermutationMap." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Argument minimising the PermutationMap." << endl);
   OldPotential = 1e+10;
   round = 0;
   do {
-    Log() << Verbose(2) << "Starting round " << ++round << ", at current potential " << OldPotential << " ... " << endl;
+    DoLog(2) && (Log() << Verbose(2) << "Starting round " << ++round << ", at current potential " << OldPotential << " ... " << endl);
     OlderPotential = OldPotential;
     do {
@@ -424,14 +419,14 @@
             } else {
               Params.DistanceIterators[Runner->nr] = Rider;  // if successful also move the pointer in the iterator list
-              Log() << Verbose(3) << "Found a better permutation, new potential is " << Potential << " vs." << OldPotential << "." << endl;
+              DoLog(3) && (Log() << Verbose(3) << "Found a better permutation, new potential is " << Potential << " vs." << OldPotential << "." << endl);
               OldPotential = Potential;
             }
             if (Potential > Params.PenaltyConstants[2]) {
-              eLog() << Verbose(1) << "The two-step permutation procedure did not maintain injectivity!" << endl;
+              DoeLog(1) && (eLog()<< Verbose(1) << "The two-step permutation procedure did not maintain injectivity!" << endl);
               exit(255);
             }
             //Log() << Verbose(0) << endl;
           } else {
-            eLog() << Verbose(1) << *Runner << " was not the owner of " << *Sprinter << "!" << endl;
+            DoeLog(1) && (eLog()<< Verbose(1) << *Runner << " was not the owner of " << *Sprinter << "!" << endl);
             exit(255);
           }
@@ -443,5 +438,5 @@
     } while (Walker->next != end);
   } while ((OlderPotential - OldPotential) > 1e-3);
-  Log() << Verbose(1) << "done." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 
 
@@ -466,7 +461,7 @@
 {
   /// evaluate forces (only the distance to target dependent part) with the final PermutationMap
-  Log() << Verbose(1) << "Calculating forces and adding onto ForceMatrix ... " << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Calculating forces and adding onto ForceMatrix ... " << endl);
   ActOnAllAtoms( &atom::EvaluateConstrainedForce, startstep, endstep, PermutationMap, Force );
-  Log() << Verbose(1) << "done." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "done." << endl);
 };
 
@@ -485,5 +480,5 @@
   bool status = true;
   int MaxSteps = configuration.MaxOuterStep;
-  MoleculeListClass *MoleculePerStep = new MoleculeListClass();
+  MoleculeListClass *MoleculePerStep = new MoleculeListClass(World::getPointer());
   // Get the Permutation Map by MinimiseConstrainedPotential
   atom **PermutationMap = NULL;
@@ -503,7 +498,7 @@
 
   // go through all steps and add the molecular configuration to the list and to the Trajectories of \a this molecule
-  Log() << Verbose(1) << "Filling intermediate " << MaxSteps << " steps with MDSteps of " << MDSteps << "." << endl;
+  DoLog(1) && (Log() << Verbose(1) << "Filling intermediate " << MaxSteps << " steps with MDSteps of " << MDSteps << "." << endl);
   for (int step = 0; step <= MaxSteps; step++) {
-    mol = new molecule(elemente);
+    mol = World::getInstance().createMolecule();
     MoleculePerStep->insert(mol);
     Walker = start;
@@ -513,11 +508,11 @@
       Sprinter = mol->AddCopyAtom(Walker);
       for (int n=NDIM;n--;) {
-        Sprinter->x.x[n] = Walker->Trajectory.R.at(startstep).x[n] + (PermutationMap[Walker->nr]->Trajectory.R.at(endstep).x[n] - Walker->Trajectory.R.at(startstep).x[n])*((double)step/(double)MaxSteps);
+        Sprinter->x[n] = Walker->Trajectory.R.at(startstep)[n] + (PermutationMap[Walker->nr]->Trajectory.R.at(endstep)[n] - Walker->Trajectory.R.at(startstep)[n])*((double)step/(double)MaxSteps);
         // add to Trajectories
         //Log() << Verbose(3) << step << ">=" << MDSteps-1 << endl;
         if (step < MaxSteps) {
-          Walker->Trajectory.R.at(step).x[n] = Walker->Trajectory.R.at(startstep).x[n] + (PermutationMap[Walker->nr]->Trajectory.R.at(endstep).x[n] - Walker->Trajectory.R.at(startstep).x[n])*((double)step/(double)MaxSteps);
-          Walker->Trajectory.U.at(step).x[n] = 0.;
-          Walker->Trajectory.F.at(step).x[n] = 0.;
+          Walker->Trajectory.R.at(step)[n] = Walker->Trajectory.R.at(startstep)[n] + (PermutationMap[Walker->nr]->Trajectory.R.at(endstep)[n] - Walker->Trajectory.R.at(startstep)[n])*((double)step/(double)MaxSteps);
+          Walker->Trajectory.U.at(step)[n] = 0.;
+          Walker->Trajectory.F.at(step)[n] = 0.;
         }
       }
@@ -568,10 +563,10 @@
     // parse file into ForceMatrix
     if (!Force.ParseMatrix(file, 0,0,0)) {
-      eLog() << Verbose(0) << "Could not parse Force Matrix file " << file << "." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Could not parse Force Matrix file " << file << "." << endl);
       performCriticalExit();
       return false;
     }
     if (Force.RowCounter[0] != AtomCount) {
-      eLog() << Verbose(0) << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Mismatch between number of atoms in file " << Force.RowCounter[0] << " and in molecule " << AtomCount << "." << endl);
       performCriticalExit();
       return false;
@@ -581,9 +576,9 @@
     for(int i=0;i<AtomCount;i++)
       for(int d=0;d<NDIM;d++) {
-        Velocity.x[d] += Force.Matrix[0][i][d+5];
+        Velocity[d] += Force.Matrix[0][i][d+5];
       }
     for(int i=0;i<AtomCount;i++)
       for(int d=0;d<NDIM;d++) {
-        Force.Matrix[0][i][d+5] -= Velocity.x[d]/(double)AtomCount;
+        Force.Matrix[0][i][d+5] -= Velocity[d]/(double)AtomCount;
       }
     // solve a constrained potential if we are meant to
@@ -652,22 +647,22 @@
   switch(Thermostat) {
      case None:
-      Log() << Verbose(2) <<  "Applying no thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying no thermostat..." << endl);
       break;
      case Woodcock:
       if ((configuration.ScaleTempStep > 0) && ((MDSteps-1) % configuration.ScaleTempStep == 0)) {
-        Log() << Verbose(2) <<  "Applying Woodcock thermostat..." << endl;
+        DoLog(2) && (Log() << Verbose(2) <<  "Applying Woodcock thermostat..." << endl);
         ActOnAllAtoms( &atom::Thermostat_Woodcock, sqrt(ScaleTempFactor), MDSteps, &ekin );
       }
       break;
      case Gaussian:
-      Log() << Verbose(2) <<  "Applying Gaussian thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Gaussian thermostat..." << endl);
       ActOnAllAtoms( &atom::Thermostat_Gaussian_init, MDSteps, &G, &E );
 
-      Log() << Verbose(1) << "Gaussian Least Constraint constant is " << G/E << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Gaussian Least Constraint constant is " << G/E << "." << endl);
       ActOnAllAtoms( &atom::Thermostat_Gaussian_least_constraint, MDSteps, G/E, &ekin, &configuration);
 
       break;
      case Langevin:
-      Log() << Verbose(2) <<  "Applying Langevin thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Langevin thermostat..." << endl);
       // init random number generator
       gsl_rng_env_setup();
@@ -679,10 +674,10 @@
 
      case Berendsen:
-      Log() << Verbose(2) <<  "Applying Berendsen-VanGunsteren thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Berendsen-VanGunsteren thermostat..." << endl);
       ActOnAllAtoms( &atom::Thermostat_Berendsen, MDSteps, ScaleTempFactor, &ekin, &configuration );
       break;
 
      case NoseHoover:
-      Log() << Verbose(2) <<  "Applying Nose-Hoover thermostat..." << endl;
+      DoLog(2) && (Log() << Verbose(2) <<  "Applying Nose-Hoover thermostat..." << endl);
       // dynamically evolve alpha (the additional degree of freedom)
       delta_alpha = 0.;
@@ -690,9 +685,9 @@
       delta_alpha = (delta_alpha - (3.*AtomCount+1.) * configuration.TargetTemp)/(configuration.HooverMass*Units2Electronmass);
       configuration.alpha += delta_alpha*configuration.Deltat;
-      Log() << Verbose(3) << "alpha = " << delta_alpha << " * " << configuration.Deltat << " = " << configuration.alpha << "." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "alpha = " << delta_alpha << " * " << configuration.Deltat << " = " << configuration.alpha << "." << endl);
       // apply updated alpha as additional force
       ActOnAllAtoms( &atom::Thermostat_NoseHoover_scale, MDSteps, &ekin, &configuration );
       break;
   }
-  Log() << Verbose(1) << "Kinetic energy is " << ekin << "." << endl;
-};
+  DoLog(1) && (Log() << Verbose(1) << "Kinetic energy is " << ekin << "." << endl);
+};
